% Lab session #3  Two-view geometry
%
% Guillermo Gallego

% You can run the entire script by pressing the F5 key
% Or, you can evaluate one or more lines by selecting them and pressing the
% F9 key (without needing to copy them to the prompt in the Command Window)

clear all % clear all variables in the workspace
close all % close all figures
clc       % clear the command window


%% Pinhole camera model. Example with a single 3-D point viewed in two images
wx = 640;
wy = 480;
tx = 60;
ty = 45;

% Compute focal lengths from FOVs
deg2rad = inline('(d/180)*pi', 'd');
fx = (wx/2)/tan(deg2rad(tx/2))
fy = (wy/2)/tan(deg2rad(ty/2))

K = [fx 0 wx/2; 0 fy wy/2; 0 0 1]; % Intrinsic camera matrix
T = [-.20 0 0]';

% Triangulation of the 3-D point
P1 = K * eye(3,4);
P2 = K * [eye(3),T];

x1 = [360,302,1].';
x2 = [330,302,1].';

[X,cost] = LinearTriangulation(x1,x2,P1,P2);
X_euc = X(1:3)/X(4) % One point
%X_euc = X(1:3,:)./repmat(X(4,:),3,1); % Multiple points


% With knwon solution:
% X = [.267 .395 3.694]';
% 
% p1 = K*X;
% p1 = p1 / p1(3,1);
% p1
% 
% p2 = K*(X+T*ones(1,size(X,2)));
% p2 = p2 / p2(3,1);
% p2
